#include "stdafx.h"
#include "h.h"
#include <winsvc.h>
#include <windows.h>
#include <stdio.h>

bool _loadService ( PSTR pszDriver );
bool _goService ( ); //  
bool _stopService ( ); //  
bool _freeService ( ); //  
bool InstallDriverWithSCManager();
bool StopDriver();
void WriteToPort(USHORT PortAdr, USHORT PortValue);
USHORT ReadFromPort(USHORT PortAdr);
HANDLE hDrv;

DWORD cbRet;


bool StopDriver()
{
	CloseHandle(hDrv);
	_stopService ( ); //  
	_freeService ( ); //  
	return true;
}




bool InstallDriverWithSCManager()
{
    bool bResult;
    PSTR pszTemp;
    char szExe[MAX_PATH];
    

    //  
    hDrv = CreateFile ( "\\\\.\\drvNAME", GENERIC_READ | GENERIC_WRITE,
                  0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
    //   ,   
    if ( hDrv == INVALID_HANDLE_VALUE )
    {
      //   
      if ( !GetModuleFileName ( GetModuleHandle ( NULL ), szExe,
                                sizeof ( szExe ) ) )
            return false;

      //      
      pszTemp = strrchr ( szExe, '\\' );

      //   
      pszTemp[1] = 0;

      //      
      strcat ( szExe, "xDRV.sys" );

      //  
      bResult = _loadService ( szExe ); ////////////////////////////////1

      //  ,   
      if ( !bResult ) return false;

      //   
      bResult = _goService ( );

      //  ,   
      if ( !bResult ) return false;

      //  
      hDrv = CreateFile ( "\\\\.\\drvNAME", GENERIC_READ |
    GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

       //   ,   
       if ( hDrv == INVALID_HANDLE_VALUE ) return false;
    }

	//MessageBox(NULL, " :  ..\n: www.lpt-port.narod.ru\nE-mail: lpt-port@narod.ru", "",MB_ICONSTOP);
    return true;
	
}



bool  _loadService ( PSTR pszDriver )
{
  SC_HANDLE hSrv;
  SC_HANDLE hMan;

  //      
  _freeService ( ); //////////////////////////////2

  //   
  hMan = OpenSCManager ( NULL, NULL, SC_MANAGER_ALL_ACCESS );
  //      
  if ( hMan )
  {
   hSrv = CreateService ( hMan, "drvNAME", "drvNAME",
   SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START,
   SERVICE_ERROR_NORMAL, pszDriver, NULL, NULL, NULL, NULL, NULL );

   //   
   CloseServiceHandle ( hMan );
   if ( hSrv == NULL ) return false;
  }
  else
   return false;

  CloseServiceHandle ( hMan );
  return true;
}

bool  _goService () 
{
   bool bRes;
   SC_HANDLE hSrv;
   SC_HANDLE hMan;

   //   
   hMan = OpenSCManager ( NULL, NULL, SC_MANAGER_ALL_ACCESS );
   if ( hMan )
   {
     //  
     hSrv = OpenService ( hMan, "drvNAME", SERVICE_ALL_ACCESS );

     //   
     CloseServiceHandle ( hMan );
     if ( hSrv )
     {
      //  
      bRes = StartService ( hSrv, 0, NULL );

      //     
      if( !bRes )
           CloseServiceHandle ( hSrv );
     }
     else
      return false;
   }
   else
    return false;

   return bRes;
}

bool  _stopService ( )
{
   bool bRes;
   SERVICE_STATUS srvStatus;
   SC_HANDLE hMan;
   SC_HANDLE hSrv;

   //   
   hMan = OpenSCManager ( NULL, NULL, SC_MANAGER_ALL_ACCESS );
   if ( hMan )
   {
     //  
     hSrv = OpenService ( hMan, "drvNAME", SERVICE_ALL_ACCESS );

     //   
     CloseServiceHandle ( hMan );
     if ( hSrv )
     {
      //  
      bRes = ControlService ( hSrv, SERVICE_CONTROL_STOP, &srvStatus );

      //  
      CloseServiceHandle ( hSrv );
     }
     else
      return false;
   }
   else
    return false;
   return bRes;
}

bool _freeService ( )
{
   bool bRes;
   SC_HANDLE hSrv;
   SC_HANDLE hMan;

   //   
   _stopService ( );/////////////////////////////3

   //   
   hMan = OpenSCManager ( NULL, NULL, SC_MANAGER_ALL_ACCESS );
   if ( hMan )
   {
     //  
     hSrv = OpenService ( hMan, "drvNAME", SERVICE_ALL_ACCESS );

     //   
     CloseServiceHandle ( hMan );
     if ( hSrv )
     {
       //        
       bRes = DeleteService ( hSrv );

       //    
       CloseServiceHandle ( hSrv );
     }
     else
       return false;
   }
   else
    return false;
   return bRes;
}


